const nodePath = require('path');
const SangjogZipExtractor = require('./sangjog-zip-extractor');
const Utils = require('./utils');


const Conf = require('./sangjog.json');
const F = {
    cr: 'create',
    gn: 'generate',
    prj: 'project',
    cnt: 'controller',
    srv: 'service'
}

class SangjogCli {

    cmd = [];

    clear() {
        this.cmd = [];
    }

    consume(cmd) {
        this.cmd = cmd;
    }

    run() {
        if(this.cmd[0]===F.cr) {
            this.cmd.shift();
            this.create();
        } else if(this.cmd[0]===F.gn) {
            this.cmd.shift();
            this.generate();
        } else {
            Utils.throwArgErr();
        }
    }

    create() {
        if(this.cmd[0]===F.prj && this.cmd.length===2) {
            this.createProject(this.cmd[1]);
        } else {
            Utils.throwArgErr();
        }
    }

    createProject(name) {
        name = Utils.getFolderName(name);
        console.log(`Please wait while creating the Sangjog Project....`);
        SangjogZipExtractor.downloadFile(Conf.project.gitZipUrl, {
            inWhichDir: nodePath.join(__dirname, '../'),
            zipFolderName: Conf.project.zipFolderName,
            devProjectName: name,
        }, ()=>{
            console.log(`Congratulation! One Sangjog Project has been created successfully....`)
        });
    }

    //TBI
    generate() {

    }

    //TBI
    generateController() {

    }

    //TBI
    generateService() {

    }

}

module.exports = new SangjogCli();